
      PROGRAM TDSYEV3
*
*       ணࠬ   PDSYEV3
*
      include 'mpif.h'
*  ⠭ - ࠬ  ..
      INTEGER            LWORK, MAXN, LDA, MAXPROCS, NOUT, LIWORK
      DOUBLE PRECISION   ZERO, MONE
      PARAMETER          ( LDA = 100, LWORK = 70, LIWORK = 42,
     $                   MAXN = 100, MAXPROCS = 512, NOUT =6,
     $                   ZERO = 0.0D+0, MONE = -1.0D+0 )
      CHARACTER          UPLO
      PARAMETER          ( UPLO = 'U' )
*     ..
*  ६ ..
      INTEGER            CTXT, I, IAM, INFO, MYCOL, MYROW, N, NB,
     $                   NPCOL, NPROCS, NPROW, IA, JA
      DOUBLE PRECISION   VL, VU, ABSTOL
*     ..
*  ᨢ ..
      INTEGER            DESCA( 9 ), IWORK( LIWORK )
      DOUBLE PRECISION   A( LDA, LDA ), W( MAXN ),
     $                   WORK( LWORK ), WORK1( 7 )
*     ..
* 譨 ணࠬ ..
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PDMATINIT, PDLAPRNT,
     $                   PDSYEV3, PDLAMCH
*     ..
* 믮塞  ..
*
* ⠭ 
*
      N = 7
      NB = 2
      NPROW = 2
      NPCOL = 2
      IA = 1
      JA = 1
      VL = -10.0D0
      VU = 10.0D0
*
* 樠  BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
      IF( ( NPROCS.LT.1 ) ) THEN
         CALL BLACS_SETUP( IAM, NPROW*NPCOL )
      END IF
*
* 樠 ⥪ BLACS'  ⪨ ᮢ
*
      CALL BLACS_GET( -1, 0, CTXT )
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
* ᫨      ⥪,
* 室   ணࠬ
*
      IF( MYROW.EQ.-1 ) GO TO 20
*
      ABSTOL = 2.0D0* PDLAMCH(CTXT,'U')
*
* 樠 ਯ   A
*
      CALL DESCINIT( DESCA, N, N, NB, NB, 0, 0, CTXT, LDA, INFO )
*
* ஥  A
*
      CALL PDMATINIT( N, A, IA, JA, DESCA, INFO )
*
*  室 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9992 )
         WRITE( NOUT, FMT = 9998 )N, N, NB, NB
         WRITE( NOUT, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NOUT, FMT = * ) ' 室  '
         WRITE( NOUT, FMT = 9988 ) UPLO
         WRITE( NOUT, FMT = 9995 ) VL, VU
         WRITE( NOUT, FMT = 9993 ) ABSTOL
         WRITE( NOUT, FMT = * ) '  DESCA'
         WRITE( NOUT, FMT = 9985 )DESCA
         WRITE( NOUT, FMT = * ) '  A'
      END IF
 9985 FORMAT( / 9I5 /)
 9988 FORMAT( / ' UPLO = ', A /)
 9995 FORMAT( / ' VL = ', D20.12, ' VU = ', D20.12 / )
 9993 FORMAT( / ' ABSTOL = ', D20.12 /)
*
      CALL PDLAPRNT( N, N, A, IA, JA, DESCA, 0, 0, 'A', NOUT, WORK1 )
*
* ᫥ ᮡ⢥ 祭
*
      CALL PDSYEV3( UPLO, N, A, IA, JA, DESCA, VL, VU, ABSTOL, M, W,
     $              WORK, LWORK, IWORK, LIWORK, INFO )
*
*  १⮢
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  '
         WRITE( NOUT, FMT = 9996 )INFO
         WRITE( NOUT, FMT = 9986 )M
         WRITE( NOUT, FMT = * ) ' ᮡ⢥ ᫠'
         DO 10 I = 1, M
            PRINT *, ' W(', I, ')=', W( I ), ';'
   10    CONTINUE
      END IF
*
      CALL BLACS_GRIDEXIT( CTXT )
   20 CONTINUE
*
      CALL BLACS_EXIT( 0 )
*
 9999 FORMAT( 'W=diag([', 4D16.12, //']);' )
*
 9992 FORMAT( / '  ணࠬ PDSYEV3' )
 9998 FORMAT( / ' ᫥ ᮡ⢥ 祭   A',
     $       '  ࢠ ( VL, VU ),' //
     $      '  A - ᨬ筠  ',
     $      I2, '  ', I2,',',
     $       ' ࠧ  ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I2, ' ,',
     $       ' ࠧ  ࠧ஬ ', I2, '  ', I2 /)
 9996 FORMAT( / ' 祭 INFO  = ', I3)
 9986 FORMAT( / ' M  = ', I3 /)
      STOP
      END
*
      SUBROUTINE PDMATINIT( N, A, IA, JA, DESCA, INFO )
*
* PDMATINIT   ।  A  ⪥ ᮢ
*
*  ⠭ - ࠬ ..
      INTEGER            DLEN_, CTXT_
      PARAMETER          ( DLEN_ = 9, CTXT_ = 2 )
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*
* ࠬ - ६ ..
      INTEGER            IA, INFO, JA, N
*
* ࠬ - ᨢ ..
      INTEGER            DESCA( * )
      DOUBLE PRECISION   A( * )
*
*  ६ ..
      INTEGER            I, J, MYCOL, MYROW, NPCOL, NPROW
*
* 譨 ணࠬ ..
      EXTERNAL           BLACS_GRIDINFO, PDELSET
*
* ७ 㭪樨 ..
      INTRINSIC          DBLE
*
* 믮塞  ..
*
      INFO = 0
*
      CALL BLACS_GRIDINFO( DESCA( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )
*
      IF( IA.NE.1 ) THEN
         INFO = -3
      ELSE IF( JA.NE.1 ) THEN
         INFO = -4
      END IF
*
      DO 2 J = 1, N
      DO 1 I = 1, N
      CALL PDELSET( A, I, J, DESCA, 0.0D0)
    1 CONTINUE
    2 CONTINUE
      DO 4 J = 1, N
      DO 3 I = 1, N
         IF( I.EQ.J ) THEN
            CALL PDELSET( A, I, J, DESCA, 1.0D0)
         END IF
    3 CONTINUE
    4 CONTINUE
      J = N
      DO 5 I = 1, N
      CALL PDELSET( A, I, J, DESCA, DBLE(I) )
    5 CONTINUE
      I = N         
      DO 6 J = 1, N
      CALL PDELSET( A, I, J, DESCA, DBLE(J) )
    6 CONTINUE
*
      RETURN
*
*     End of PDMATINIT
*
      END
